/**
 * Created by felipesantos on 08/11/2016.
 */
function ContainerDecorator(ZHPromise) {
    this.apply = function(containerName, container) {
        var defered = ZHPromise.defer();
        if (containerName && container && Util.isObject(container)) {
            var gridPreferencesTemplates = [
                "widget/master_detail/grid.html",
                "widget/grid.html"
            ];
            container.widgets.forEach(function(widget){
                if (gridPreferencesTemplates.indexOf(widget.template) >= 0 && Util.isUndefined(widget.floatingControl)) {
                    widget.floatingControl = {
                        "draggable": true,
                        "searchAction": true,
                        "customizationAction": {
                            "layout": true,
                            "filter": true,
                            "view" : true
                        }
                    };
                }
            });

            defered.resolve(container);
        }
        return defered.promise;
    };
}

Configuration(function(ContainerDecoratorProvider, ZHPromise) {
    ContainerDecoratorProvider.registerProvider(new ContainerDecorator(ZHPromise));
});