<?php

namespace HCM\FPA\Services;

use Doctrine\DBAL\Connection;
use HCM\Util\HCMParameters;
use HCM\Util\FPA;
use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use HCM\Util\Messages;
use HCM\Util\Util;
use HCM\FPA\Repository\CNABRepository;


class CNABService {

    public function __construct (EntityManager $entityManager, HCMParameters $hcmParameters, Environment $environment, CNABRepository $CNABRepository){
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->hcmParameters = $hcmParameters;
        $this->CNABRepository = $CNABRepository;
    }

    public function deletaMagneticos($nrorg, $nrTpMov, $nrBanco, $competencia) {
        $this->CNABRepository->deletaMagneticos($nrorg, $nrTpMov, $nrBanco, $competencia);
    }
}