-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     15/09/2023  09:46
--   Issue:          437461 - Relatório de Extrato do Banco deve ser gerado a partir da tela de "Leitura de Arquivo - CNAB";
-- ============================================================

-- ============================================================
--   Table: FPA_RETORNOCNAB                               
-- ============================================================

CREATE TABLE FPA_RETORNOCNAB (
    NRORG                 NUMBER          NOT NULL,
    NRRETORNOCNAB         NUMBER          NOT NULL,
    NMARQUIVO             VARCHAR2(200)   NOT NULL,
    DTPAGAMENTO           VARCHAR2(10)    NULL,
    AGENCIA               VARCHAR2(200)   NULL,
    CODIGO                VARCHAR2(200)   NULL,
    CONTA                 VARCHAR2(200)   NULL,
    NMVINCULO             VARCHAR2(200)   NULL,
    ERRO                  VARCHAR2(200)   NULL,
    DTRETORNO             VARCHAR2(200)   NULL,
    NMEMPRESA             VARCHAR2(200)   NULL,
    CNPJEMPRESA           VARCHAR2(200)   NULL,
    CONTAEMPRESA          VARCHAR2(200)   NULL,
    AGENCIAEMPRESA        VARCHAR2(200)   NULL,
    POSICOES              VARCHAR(10)     NULL,
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_FPA_RETORNOCNAB PRIMARY KEY (NRORG, NRRETORNOCNAB)
);

ALTER TABLE FPA_RETORNOCNAB ADD VALOR VARCHAR(200) NULL;
ALTER TABLE FPA_RETORNOCNAB ADD BANCO VARCHAR(200) NULL;